#
# spec file for package ucode-intel
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           ucode-intel
Version:        20170511
Release:        8.1
Summary:        Microcode Updates for Intel x86/x86-64 CPUs
License:        SUSE-Firmware
Group:          Hardware/Other
BuildRequires:  suse-module-tools
#License is: Intel Software License Agreement
Url:            https://downloadcenter.intel.com/download/25512/Linux-Processor-Microcode-Data-File
Source0:        microcode-%{version}.tgz
Source1:        intel-microcode2ucode.c
Source2:        LICENSE
Supplements:    modalias(x86cpu:vendor%3A0000%3Afamily%3A*%3Amodel%3A*%3Afeature%3A*)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires(post): coreutils
Requires(postun): coreutils
ExclusiveArch:  %ix86 x86_64

%description
This package contains the microcode update blobs for Intel x86 and x86-64 CPUs.

%package blob
Summary:        Latest Microcode for Intel x86/x86-64 CPUs
Group:          Hardware/Other

%description blob
This package contains the microcode update for Intel x86 and x86-64 CPUs in a single blob.

%prep
%setup -q -c intel-ucode
cp %{SOURCE2} .

%build
%{__cc} -fwhole-program %{optflags} %{SOURCE1} -o generate_microcode
./generate_microcode microcode.dat

%install
install -D -m 0755 GenuineIntel.bin %{buildroot}/lib/firmware/GenuineIntel.bin
install -D -m 0755 generate_microcode %{buildroot}%{_bindir}/generate_microcode
for file in intel-ucode/*; do
install -D -m 0644 $file %{buildroot}/lib/firmware/$file
done

%post
%{?regenerate_initrd_post}

%postun
%{?regenerate_initrd_post}

%posttrans
%{?regenerate_initrd_posttrans}

%files
%defattr(-,root,root)
%doc LICENSE
%{_bindir}/generate_microcode
/lib/firmware/intel-ucode/

%files blob
%defattr(-,root,root)
/lib/firmware/GenuineIntel.bin

%changelog
* Tue May 16 2017 idonmez@suse.com
- Update to version 20170511
* Mon Dec  5 2016 crrodriguez@opensuse.org
- Update to version 20161104.
* Thu Jul 21 2016 trenn@suse.de
- Update to version 20160714.
- Should fix bsc#987358, a bug which got introduced with the last
  release.
- Should finally fix "Intel Skylake bug" (bnc#993639), previous
  releases since Jan 2016 may or may not have completely fixed it.
* Thu Jun 23 2016 crrodriguez@opensuse.org
- Update to version 20160607, no changelog available
* Thu Dec 10 2015 tiwai@suse.de
- Fix dependency on coreutils for initrd macros (boo#958562)
- Call missing initrd macro at postun (boo#958562)
* Tue Nov 10 2015 fvogt@suse.com
- Fix Url and Source0
- Add GenuineIntel.bin to ucode-intel-blob
* Tue Nov 10 2015 p.drouand@gmail.com
- Update to version 20151106
  * No changelog available
- Use download Url as source
* Mon Nov  2 2015 fvogt@suse.com
- Add ucode-intel-blob subpackage to get the full microcode.dat
    directly
* Thu Mar 19 2015 crrodriguez@opensuse.org
- Update to microcode 20150121.
* Wed Jan 21 2015 mpluskal@suse.com
- Pre require coreutils (bnc#914169).
* Fri Sep 19 2014 trenn@suse.de
- Do not try to reload/update microcode at runtime after package
  installation. Only supported way of updating microcode is via
  early microcode update via initrd. bnc#896736
* Wed Sep 17 2014 trenn@suse.de
- Update to Intel microcode version 20140624 (bnc#896736, fate#317896)
  This microcode disables lock elision on CPUs which are known to
  not work reliable with this feature
* Wed Jul  2 2014 tiwai@suse.de
- Update to Intel microcode version 20140624 (bnc#885213)
* Fri Jun 13 2014 trenn@suse.de
- Delete mkinitrd scripts. This is done via %%rpm regenerate_initrd_* macros
  (bnc#894160)
* Mon May  5 2014 trenn@suse.de
- Update to Intel microcode version 20140430 (bnc#876073)
* Fri Apr  4 2014 mmarek@suse.cz
- Regenerate the initrd in %%posttrans (fate#313506)
* Tue Feb 11 2014 idonmez@suse.com
- ucode 20140122, no changelog available.
* Tue Dec 10 2013 trenn@suse.de
- Loading firmware needs udev to be running
* Mon Dec  2 2013 trenn@suse.de
- Add mkinitrd script to add Intel microcode to initrd.
  This is needed because microcode driver is built in or gets loaded
  automatically via udev early. Therefore the microcode has to be available
  in initrd already.
  This must not be mixed up with early micorcode loading. This feature will
  not be implemented via mkinitrd. Dracut is doing early microcode loading.
- bnc#847158
- mkinitrd scripts:
  - mkinitrd_setup-intel_microcode.sh
    Adding microcode to the initrd
  - mkinitrd_boot-intel_microcode.sh
    Triggering the reload at boot
* Mon Nov 25 2013 trenn@suse.de
- Correct Supplements string so that the package gets correctly installed
  on machines with Intel CPUs
  bnc#847158
* Sun Sep 22 2013 crrodriguez@opensuse.org
- ucode 20130906, no changelog available.
* Fri Aug 30 2013 crrodriguez@opensuse.org
- ucode 20130808, as usual, no changelog available.
* Thu Jul 25 2013 aj@suse.com
- Run spec-cleaner
* Wed Jul 24 2013 jeffm@suse.com
- Initial packaging. Moved microcode from microctl_ctl package.
